(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     43748,       1400]*)
(*NotebookOutlinePosition[     74007,       2497]*)
(*  CellTagsIndexPosition[     73963,       2493]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["MathCode C++  Release Notes", "Title"],

Cell["Version 1.4.4", "Subtitle",
  CellChangeTimes -> {{3.508482253240473*^9, 3.508482253771716*^9}}],

Cell["March 3,  2011", "Subsubtitle",
  CellChangeTimes -> {{3.5084822572716713`*^9, 3.5084822670059214`*^9}}],

Cell[CellGroupData[{

Cell["Troubleshooting and support", "Section"],

Cell[TextData[{
  "Always use the latest MathCode version available.  On  Windows always \
start MathCode using Start Menu (or ",
  StyleBox["StartMathCode.bat",
    FontWeight->"Bold"],
  ")\nIf ",
  StyleBox["Demos/SimplestExample/SimplestExample.nb",
    FontWeight->"Bold"],
  " fails then all other compilation attempts will fail as well. Execute the \
notebook ",
  StyleBox["Demos/Troubleshoot/MathCodeSetupVerify.nb",
    FontWeight->"Bold"],
  " . It covers typical troubleshooting situations. \nIn case of compilation \
errors that appear in your example please send  whole notebook to \
support@MathCore.com. \nList of supported ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " functions is available at ",
  StyleBox[ButtonBox["http://www.MathCore.com/products/mathcode/mathcodec++_\
subset.pdf",
    ButtonData:>{
      URL[ 
      "http://www.mathcore.com/products/mathcode/mathcodec++_subset.pdf"], 
      None}],
    ButtonBoxOptions -> {BaseStyle -> "Hyperlink"}]
}], "Text",
  CellChangeTimes -> {3.508482290661869*^9, 3.50916983846894*^9, \
{3.509169884484565*^9, 3.50916993837519*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.4.6 (Windows, MacOSX, Linux)", "Section",
  CellChangeTimes -> {{3.493444008038536*^9, 3.493444036381379*^9}}],

Cell[TextData[{
  StyleBox["Support for ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" 9.0 release.\nMathCode F90: Support for \"gfortran\" F90 \
compiler.\nMathCode F90: Support for external functions written in Fortran \
90.",
    FontWeight->"Bold"]
}], "Text",
  CellChangeTimes -> {{3.493444015788288*^9, 3.4934441033636107`*^9}, \
{3.49344480757545*^9, 3.49344508850396*^9}, {3.493445125159037*^9, \
3.4934452576235485`*^9}, {3.4934453208402753`*^9, 3.4934453414333663`*^9}, \
{3.493445391744256*^9, 3.4934454552734733`*^9}, {3.4934454988502035`*^9, \
3.493445544958103*^9}, {3.4934455895660505`*^9, 3.493445598268897*^9}, \
{3.4934457400143614`*^9, 3.493445768060339*^9}, {3.4934457993405876`*^9, \
3.493445902259169*^9}, {3.493446468022314*^9, 3.4934464999119186`*^9}, \
{3.50916995321894*^9, 3.509169962797065*^9}, {3.509170052422065*^9, \
3.509170127359565*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.4.4 (Windows, MacOSX, Linux)", "Section",
  CellChangeTimes -> {{3.493444008038536*^9, 3.493444036381379*^9}}],

Cell[TextData[{
  StyleBox["Support for MacOSX-64 bit ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" releases.\nSupport for Microsoft Visual C++  Express 2010\n\
Support for ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" 8 (note: the old free mingw32 compiler from 1998 cannot be \
used).\nLine and column number is added to many error messages related to \
symbols in ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" code.\nAllowed an iterator without list constructor.\nBetter \
diagnostics of Import[] during compilation.\nCan handle explicit list \
constructors for up to 100 elements (was 10 before).\nStricter type \
compatibility check for \"return\" expressions.\nFix of division of Complex \
numbers.\nFix of type derivation for Equals[].\nLinux Intel Fortran (for \
MathCode F90 1.2.3 only).\nBetter diagnostics for Sum[] calls.\nBetter \
diagnostics when license errors and license key mismatch occurs.\nNested \
A[B][C]=... allowed and fixed.\nFix for Cygwin 1.7+ warnings due to posix \
compatibility requirements.\nReport functions that were declared, but had no \
data-types in declaration.\nWarn about SetShape() function in runtime library \
that cannot change the shape of copy of array fragment.\nWarn when \
compilation using BuildCode does not continue further to MakeBinary.  \n\
Round[] handles Complex -> Complex. ",
    FontWeight->"Bold"]
}], "Text",
  CellChangeTimes -> {{3.493444015788288*^9, 3.4934441033636107`*^9}, \
{3.49344480757545*^9, 3.49344508850396*^9}, {3.493445125159037*^9, \
3.4934452576235485`*^9}, {3.4934453208402753`*^9, 3.4934453414333663`*^9}, \
{3.493445391744256*^9, 3.4934454552734733`*^9}, {3.4934454988502035`*^9, \
3.493445544958103*^9}, {3.4934455895660505`*^9, 3.493445598268897*^9}, \
{3.4934457400143614`*^9, 3.493445768060339*^9}, {3.4934457993405876`*^9, \
3.493445902259169*^9}, {3.493446468022314*^9, 3.4934464999119186`*^9}, \
{3.50916995321894*^9, 3.509169962797065*^9}, {3.509170052422065*^9, \
3.509170127359565*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.4.3 (Windows)", "Section"],

Cell[TextData[{
  StyleBox["Support for ",
    FontWeight->"Bold"],
  StyleBox["MathCode ",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox["syntax extensions without MathCode being loaded.\nSupport for \
Span[a,b]  x[[a;;b]] in MathCode syntax extensions \nSupport for Min[a,b] \
where types of a and b are mixed (double and int)\nMore clear limitations for \
Table[]  (only identifier might be on the left from  a=Table[])\nFixes for \
type derivation for IntegerPart[Complex] and several similar functions.",
    FontWeight->"Bold"]
}], "Text",
  CellChangeTimes -> {3.509169977953315*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.4.2 (Windows)", "Section"],

Cell[TextData[{
  StyleBox["Support for ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" 7.0",
    FontWeight->"Bold"]
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.4.1 (Windows)", "Section"],

Cell[TextData[StyleBox["Support for Windows Vista\nSupport for the latest \
Microsoft Visual C++   2008 Express Edition\nA new Random[] demo. ",
  FontWeight->"Bold"]], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.4 (Linux, Windows, MacOSX)", "Section"],

Cell[TextData[{
  StyleBox["Support for ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" 6.0\nFirst MathCode release for MacOSX platform (",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" 5.2.2 and 6.0 only, Intel processors only) . \n",
    FontWeight->"Bold"],
  "Note: ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 5.2.0 is not supported on MacOSX.",
  StyleBox["\nFirst MathCode release for Windows XP 64 platform (intended for \
32-bit Visual C++ or MINGW32 compiler).\nNew functions for file I/O : \
Import[], Export[],  \nNew functions for vector and matrix manipulation: \
Append[], Prepend[], Drop[], Join[], Flatten[]\nNew functions for statistics: \
Mean[], Variance[], StandardDeviation[], Median[], Sort[], Quantile[]\nNew \
demo examples: FFT (Fast Fourier Transform)\nNew interface capabilities to \
latest compilers were added:\n",
    FontWeight->"Bold"],
  "Visual C++ 2005 Studio and Visual C++ 2005 Express edition (Windows only)\n\
Support for g++ of versions up to 4.1 (Linux and MacOSX only)\nSeveral new \
demo examples were added."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.3.2 (Linux and Windows)", "Section"],

Cell[TextData[{
  StyleBox["New interface capabilities to latest compilers were added:\n",
    FontWeight->"Bold"],
  "CYGWIN g++ compiler, Visual C++ 2005 Express edition (Windows only)\nIn \
MathCode  1.3.2  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " versions less than 6.0 are supported only.\nInstallation script has \
better control over installed C++ compilers (Windows only)\nInstallation \
script can handle various Linux releases, including Linux-x64 with g++ of \
versions up to 3.4.9 (Linux only)\nSeveral new demo examples were added."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.3.1 (Windows)", "Section"],

Cell[TextData[{
  StyleBox["Several problems were fixed after release of version 1.3:\n",
    FontWeight->"Bold"],
  "Fixed some problems with Power[] function  for complex numbers\n$Context \
fixed in case of errors\nMathCodeContext fixed for BeginPackages[]\nBetter \
documentation of Makefiles\nCompoundExpression in Table[*,...] is not \
disassembled, therefore fixed problem with Table[(statement,expression),...]\n\
Better documented erroneous situations when MathCode context and $Path are \
wronly used. \nIn MathCode  1.3.1  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " versions less than 6.0 are supported only.\nInstallation script has \
better control over installed C++ compilers (Windows only)"
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.3 (Windows)", "Section"],

Cell[TextData[{
  "This version includes possibility to work with ",
  StyleBox["Complex",
    FontWeight->"Bold"],
  " numbers and lists of ",
  StyleBox["Complex",
    FontWeight->"Bold"],
  " numbers. Complex numbers and lists of them can be passed as arguments to \
the most of numerical functions. The full list of these functions can be \
found in Appendix A of  the User Manual (section A.2.9). Note that updated \
version of the manual in pdf-format can be found in MathCode installation. \n\
This version includes several extra Demo examples which illustrate numerical \
integration and interpolation.\nThis version requires that user chooses the \
appropriate C++ compiler during installation. In addition, this version \
includes a configurator in order to switch easily between several C++ \
compilers available on Windows.\nFortran code generation is available as a \
separate product, MathCode F90. "
}], "Text"],

Cell[CellGroupData[{

Cell["Configuring environment variables for C++ compiler.", "Subsection"],

Cell[TextData[{
  "You do not need anymore to bother about environment variables.  Start \
Mathcode using Start Menu (or directly ",
  StyleBox["StartMathCode.bat",
    FontWeight->"Bold"],
  "). It sets all necessary variables for the compiler you chose."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.2 (Linux, Windows and Solaris)", "Section"],

Cell[TextData[{
  "\nThis version includes the following important capabilities: Fortran90 \
code generation and compatibility with ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 5.0"
}], "Text"],

Cell[CellGroupData[{

Cell["\<\
Fortran90 code generation (available as a separate product only, MathCode F90 \
since 2005)\
\>", "Subsection"],

Cell[TextData[{
  "Fortran90 code generation is a new feature of MathCode. In order to use it \
you first install Digital Visual Fortran 6.0 and MicroSoft Visual C++ 6.0. \
They both must be installed such way that necessary environment variables are \
set in the System properties / Environment. \nIt means that ",
  StyleBox["df",
    FontWeight->"Bold"],
  " and ",
  StyleBox["cl",
    FontWeight->"Bold"],
  " are availale in the ",
  StyleBox["PATH",
    FontWeight->"Bold"],
  ", as well as  ",
  StyleBox["LIB",
    FontWeight->"Bold"],
  " and ",
  StyleBox["INCLUDE",
    FontWeight->"Bold"],
  " are set correctly\nThe dialog box allowing to do this automatically \
appears at the very end of setup of Digital Visual Fortran 6.0 and MicroSoft \
Visual C++ 6.0.  \nThere exist a directory DemosF90 with several demo \
examples of functions compiled to Fortran90. \nThe ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " language implemented in the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " to Fortran90 compiler is identical to the subset implemented in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " to C++ compiler, except of External Functions. These are not implemented \
yet.    \nBy default C++ code is generated. In order to activate Fortran90 \
code generation add the rule in SetCompilationOptions: ",
  Cell[BoxData[
      \(\(\(\ \ \)\(SetCompilationOptions[
        Language \[Rule] "\<Fortran90\>"]; \)\)\)], "Input"],
  "\nAvailablility of Fortran90 code generator depends on your MathCode \
license."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Mathematica 5.0 compatibility\
\>", "Subsection"],

Cell[TextData[{
  "MathCode 1.2 is compatible with Mathematica 5.0, 5.1, 5.2. Several \
routines had to be changed in order to provide this compatibility. \nIf you \
use XML package symbol ",
  StyleBox["Declare",
    FontWeight->"Bold"],
  " you should note that it is made non-available in MathCode due to names \
conflict. Do not load MathCode and XML simultaneously."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solaris/UltraSparc vertsion", "Subsection"],

Cell["\<\
The Solaris/UltraSPARC version contains the LightMat run-time library for \
sevearl different compliers. Please check that your compiler corresponds to \
specifications in MathCodeConfig.m\
\>", "Itemize"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Bugfixes\
\>", "Subsection"],

Cell["These major bugs (as well as several minor bugs) were fixed:", "Itemize"],

Cell["ArcTan bug fixed", "Itemize"],

Cell["\<\
Fortran stub for 3D ,4D arrays  (for external Fortran functions)fixed\
\>", "Itemize"],

Cell["Spell (octal digits) bug fixed", "Itemize"],

Cell["Missing compiler messages (when using mingw32) bug fixed", "Itemize"]
}, Open  ]],

Cell[CellGroupData[{

Cell["MathCode Compiler messages", "Subsection"],

Cell[TextData[{
  "Messages from the compiler are often pretty long and get shortened by ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " using ",
  StyleBox["Short[]", "InlineInput"],
  ". This shortening can be prevented by doing this:"
}], "Text"],

Cell[BoxData[
    \($MessagePrePrint = Identity; \)], "Input"],

Cell[TextData[{
  "This will make ",
  StyleBox["Message[]", "InlineInput"],
  " always print the full text of messages."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.1", "Section"],

Cell[TextData[{
  "The big addition to 1.1 is the inclusion of the Free C++ compiler EGCS in \
the Windows version. Other items are some bugfixes, a new license \
verification method, the users guide as ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " notebooks, and a runtime configuration file to facilitate switching \
between different compilers."
}], "Text"],

Cell[CellGroupData[{

Cell["Online manual in notebook format", "Subsection"],

Cell[TextData[{
  "Besides PostScript and PDF formats, MathCode now also comes with the users \
guide in notebook format. After installation, open ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " and select the Help/Rebuild Help Index menu item. Now you can use ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s help browser to browse the MathCode users guide."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Runtime configuration", "Subsection"],

Cell[TextData[{
  "There is now a file ",
  StyleBox["MathCodeConfig.m",
    FontFamily->"Courier"],
  " in the main MathCode directory. This file is really a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " package that contains some configuration directives; currently ",
  StyleBox["DefineCompiler[] ", "InlineInput"],
  "and ",
  StyleBox["DefaultCompiler[]", "InlineInput"],
  "."
}], "Text"],

Cell[TextData[{
  StyleBox["DefineCompiler[]", "InlineInput"],
  " is used to associate a symbolic compiler name (a string) with a make \
file, a command template, and a build command.  You don't normally need to \
bother with these details."
}], "Text"],

Cell[TextData[{
  StyleBox["DefaultCompiler[]", "InlineInput"],
  " is used to select the default compiler definition for a language. \
Currently the only language supported for code generation is C++. In ",
  StyleBox["MathCodeConfig.m",
    FontFamily->"Courier"],
  " you will find a line"
}], "Text"],

Cell[BoxData[
    \(DefaultCompiler["\<C++\>" -> "\<mingw32\>"]; \)], "Input"],

Cell["\<\
This tells MathCode to use the included \"mingw32\" compiler definition when \
generating C++ code. If you wish to use Visual C++ instead, you should change \
this to read:\
\>", "Text"],

Cell[BoxData[
    \(DefaultCompiler["\<C++\>" -> "\<vc60\>"]; \)], "Input"],

Cell[TextData[{
  "Using a different compiler can be easier than that, with the new options \
to ",
  StyleBox["CompilePackage[]", "InlineInput"],
  ", ",
  StyleBox["MakeBinary[]", "InlineInput"],
  " and ",
  StyleBox["BuildCode[]", "InlineInput"],
  ". "
}], "Text"],

Cell[TextData[{
  StyleBox["CompilePackage[]", "InlineInput"],
  " now takes a ",
  StyleBox["Language", "InlineInput"],
  " option (currently only C++ is supported). MathCode will then use the \
default compiler for the specified language. Example:"
}], "Text"],

Cell[BoxData[
    \(CompilePackage[Language -> "\<C++\>"]; \)], "Input",
  Evaluatable->False],

Cell["\<\
MakeBinary[] now takes a Compiler option; the option value should be one of \
the symbolic names (strings) defined using DefineCompiler[]. The Compiler \
option to MakeBinary overrides the default compiler specified for the \
selected language. Example:\
\>", "Text"],

Cell[BoxData[
    \(MakeBinary[Compiler -> "\<g++\>"]; \)], "Input"],

Cell[TextData[{
  "As usual, ",
  StyleBox["BuildCode[]", "InlineInput"],
  " can be given both ",
  StyleBox["CompilePackage[]", "InlineInput"],
  " and ",
  StyleBox["MakeBinary[]", "InlineInput"],
  " options. The following example will generate C++ code and use the \"CC\" \
compiler to compile it, overriding any default specification:"
}], "Text"],

Cell[BoxData[
    \(BuildCode[Language -> "\<C++\>", \ Compiler -> "\<CC\>"]; \)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["The included compiler(s) (Windows only)", "Subsection"],

Cell[TextData[{
  "The Windows version of MathCode C++ now ships with the free EGCS compiler. \
EGCS stands for Experimental GNU Compiler System and is by far the most \
popular of the free compilers. EGCS contains a C compiler (gcc), a C++ \
compiler (g++) and a FORTRAN 77 compiler (g77). The included Windows port is \
the mingw32 port from Mehmet Khan's pages.\nThis table shows what is \
installed in the ",
  StyleBox["MathCode\\mingw32",
    FontFamily->"Courier"],
  " directory during the MathCode installation process:\n",
  Cell[BoxData[GridBox[{
          {
            StyleBox["Files",
              "Text",
              FontWeight->"Bold"], 
            StyleBox[\(Source\ \((URL)\)\),
              "Text",
              FontWeight->"Bold"]},
          {
            RowBox[{
              RowBox[{
                StyleBox["contents",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox["of",
                  "Text"], 
                StyleBox[" ",
                  "Text"], "egcs"}], "-", \(1.1  .2\), 
              "-", \(mingw32 . zip\)}], 
            
            ButtonBox[\(\(\(ftp\)\(:\)\) // \(\(ftp . xraylith . wisc . edu/
                        pub\)/khan\)/gnu - \(win32/mingw32\)/egcs - 
                  1.1 \( \(.2\)\(/\)\)\),
              ButtonData:>{
                URL[ 
                "ftp://ftp.xraylith.wisc.edu/pub/khan/gnu-win32/mingw32/egcs-\
1.1.2/"], None}]},
          {
            RowBox[{
              RowBox[{
                RowBox[{
                  StyleBox["contents",
                    "Text"], 
                  StyleBox[" ",
                    "Text"], 
                  StyleBox["of",
                    "Text"], 
                  StyleBox[" ",
                    "Text"], "i386"}], "-", "mingw32", "-", \(make . zip\)}], 
              " "}], 
            
            ButtonBox[\(\(\(ftp\)\(:\)\) // \(\(ftp . xraylith . wisc . edu/
                        pub\)/khan\)/
                    gnu - \(\(\(win32/mingw32\)/ports\)\(/\)\)\),
              ButtonData:>{
                URL[ 
                "ftp://ftp.xraylith.wisc.edu/pub/khan/gnu-win32/mingw32/ports/\
"], None}]},
          {\(libml32i1 . a\), 
            RowBox[{
              StyleBox["Produced",
                "Text"], 
              StyleBox[" ",
                "Text"], 
              StyleBox["by",
                "Text"], 
              StyleBox[" ",
                "Text"], 
              StyleBox["MathCore",
                "Text"], 
              StyleBox[" ",
                "Text"], 
              StyleBox["from",
                "Text"], " ", \(ml32i1m . lib\), " ", 
              StyleBox["of",
                "Text"], 
              StyleBox[" ",
                "Text"], 
              StyleBox["the",
                "Text"], 
              StyleBox[" ",
                "Text"], 
              StyleBox["Mathematica",
                "Text"], 
              StyleBox[" ",
                "Text"], 
              StyleBox["distribution",
                "Text"]}]}
          }]]],
  "\nThe original files can also be found in the GNU subdirectory of the \
MathCode CD.\nMore information about EGCS can be found in the following \
locations:"
}], "Text"],

Cell[TextData[StyleBox[ButtonBox["http://www.xraylith.wisc.edu/~khan/software/\
gnu-win32/",
  ButtonData:>{
    URL[ "http://www.xraylith.wisc.edu/~khan/software/gnu-win32/"], None}],
  ButtonBoxOptions -> {BaseStyle -> "Hyperlink"}]], "Itemize"],

Cell[TextData[{
  StyleBox[ButtonBox["http://sourceware.cygnus.com/cygwin",
    ButtonData:>{
      URL[ "http://sourceware.cygnus.com/cygwin"], None}],
    ButtonBoxOptions -> {BaseStyle -> "Hyperlink"}],
  " "
}], "Itemize"],

Cell[TextData[{
  "  More information about free software in general can be found at ",
  StyleBox[ButtonBox["http://www.gnu.org/fsf/",
    ButtonData:>{
      URL[ "http://www.gnu.org/fsf/"], None}],
    ButtonBoxOptions -> {BaseStyle -> "Hyperlink"}]
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["About license verification", "Subsection"],

Cell[TextData[{
  "License information is distributed by MathCore in the form of key files, \
containing encoded license data. To create a key file, MathCore needs the \
MathID (the value of the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " variable ",
  StyleBox["$MachineID", "InlineInput"],
  ") for the machine the license is intended for. The normal procedure is to \
distribute key files as e-mail attachments. To install a new license, simply \
save the attached file to the ",
  StyleBox["Licensing",
    FontFamily->"Courier"],
  " subdirectory of your MathCode installation. Any number of key files can \
be put in this directory; MathCode automatically updates an index file (",
  StyleBox["index.m",
    FontFamily->"Courier"],
  ") keeping track of machine identities and key files. On a site/network \
installation, this file and the ",
  StyleBox["Licensing",
    FontFamily->"Courier"],
  " subdirectory needs to be world writable if normal users should be allowed \
to install license files."
}], "Text"],

Cell["\<\
You also have the opportunity to select a key file during the installation \
process. Obtaining a key file for your machine before installing MathCode \
thus makes the process a bit smoother.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bugfixes", "Subsection"],

Cell[TextData[{
  "MathCode used to produce strange errors when the ",
  StyleBox["*^", "InlineInput"],
  " notation for very large or very small numbers were used. This has been \
fixed in version 1.1."
}], "Text"],

Cell[TextData[{
  "Some people were confused when MathCode reported two generated functions \
when they had only defined one. The extra function is of course the ",
  StyleBox["packagename",
    FontSlant->"Italic"],
  "_init function. This function is now excluded from the function count."
}], "Text"],

Cell[TextData[{
  StyleBox["CompilePackage[]", "InlineInput"],
  " without an argument and with no active package compiles the ",
  StyleBox["Global`",
    FontFamily->"Courier"],
  " context."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Other changes", "Subsection"],

Cell[TextData[{
  StyleBox["InterpolatingFunctionObjects", "InlineInput"],
  " has changed name to ",
  StyleBox["InterpolatingFunctionNames", "InlineInput"],
  ". This is more appropriate as it is the names of the objects that are \
given, not the objects themselves. We feel that the MathCode support for \
interpolating function objects hasn't been around long enough for this change \
to be a big compatibility issue."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["New in 1.03", "Section"],

Cell[TextData[{
  "Most of the improvements in 1.03 are in the Windows 95/98/NT installation \
procedure, which has undergone a major overhaul. The only added functionality \
in 1.03 is the definition of ",
  StyleBox["Erf", "InlineInput"],
  " in System.nb."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["New in 1.02", "Section"],

Cell["\<\
The functional addition to version 1.02 is the ability to compile \
interpolating function objects. The use of interpolating function objects is \
described in a new demo notebook.\
\>", "Text"],

Cell["There are also minor updates and bugfixes in serveral areas", "Text"],

Cell["\<\
Some combinations of input/output/inout arguments to  external functions did \
not work properly.\
\>", "Itemize",
  FontSize->12],

Cell["\<\
Some combinations of arguments to callback functions did not work properly.\
\>", "Itemize",
  FontSize->12],

Cell["\<\
Paths with spaces were not correctly handled in Windows (they are not allowed \
in MathCode for UNIX).\
\>", "Itemize",
  FontSize->12],

Cell["\<\
Visual C++ 6.0 doesn't allow extra WinMain() functions; MathCode has been \
updated accordingly.\
\>", "Itemize",
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell["Caveats", "Section"],

Cell[CellGroupData[{

Cell["Configuring Visual C++", "Subsection"],

Cell["\<\
Visual C++ must be configured for \"command line compilation\" for MathCode \
to be able to call it. Here's how to configure it.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Windows NT", "Subsubsection"],

Cell["\<\
Re-run the Visual C++ installation (only missing or corrupt files will be \
updated). At the end you will be presented with a dialog \"Setup Environment \
Variables\". Check the box \"Register Environment Variables\" and finish the \
installation.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Windows 95/98", "Subsubsection"],

Cell["\<\
Under Windows 95/98, the environment variables necessary for command line \
compilation are installed using a batch file. The trick is to make the \
command prompt execute the batch file whenever it is opened.\
\>", "Text"],

Cell[TextData[{
  "1. Locate the file \"",
  StyleBox["command.pif",
    FontFamily->"Courier"],
  "\" e.g. using \"Find/Files or Folders...\" on the Start menu.\n2. \
right-click on the file and select \"properties\" from the menu.\n3. Under \
the \"Program\" tab, in the \"Batch file\" box, enter the path to your ",
  StyleBox["VCVARS32.BAT",
    FontFamily->"Courier"],
  " file, in quotes. Example:"
}], "Text"],

Cell[BoxData[
    \("\<C:\Program Files\Microsoft Visual \
Studio\Vc98\Bin\VCVARS32.BAT\>"\)], "Input"],

Cell["The quotes are necessary if the path contains any spaces.", "Text"],

Cell["\<\
4. Under the \"Memory\" tab, select \"1024\" from the drop-down box named \
\"Initial Environment\".\
\>", "Text"],

Cell[TextData[{
  "5. Save these changes to ",
  StyleBox["command.pif",
    FontFamily->"Courier"],
  "."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["C++ Compiler warnings", "Subsection"],

Cell[TextData[{
  "We try to keep MathCode compatible with many C++ compilers, but sometimes \
an error or two creeps in. In Windows you might see the following message \
during ",
  StyleBox["MakeBinary", "InlineInput"],
  " or ",
  StyleBox["BuildCode", "InlineInput"],
  ":"
}], "Text"],

Cell[BoxData[
    \(Ccompiler::"warning" : \ 
      "C/C++ compiler:\!\(\"LINK : warning LNK4089: all references to \" \"\\\
\"GDI32.dll\\\" discarded by /OPT:REF\"\)"\)], "Message"],

Cell[TextData[{
  "This message can be safely ignored. If you find it annoying, it can be \
suppressed by editing the file ",
  StyleBox["MathCode\\System\\compwin.mak. ",
    FontFamily->"Courier"],
  "Look for this line:"
}], "Text"],

Cell[BoxData[
    \(LINKFLAGS\  = \ $ \((LINKOPT)\)\ /\(LIBPATH : \
"\<$(MATHLINK)\lib\>"\)\)], "Input"],

Cell[TextData[{
  "Comment out this line by inserting a dash (#) as the first character. \
Below this line you can se a commented out line that also defines the ",
  StyleBox["LINKFLAGS",
    FontFamily->"Courier"],
  " variable with some additions:"
}], "Text"],

Cell[BoxData[
    \(#  LINKFLAGS\  = $ \((LINKOPT)\)\ /\(LIBPATH : "\<$(MATHLINK)\lib\>"\ /\
\(include : __imp  __GetStockObject@4\)\)\)], "Input"],

Cell["\<\
Remove the dash in front to use this definition. This will prevent the \
message on our computers at MathCore; probably for you too.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["MathCode Compiler messages", "Subsection"],

Cell[TextData[{
  "Messages from the compiler are often pretty long and get shortened by ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " using ",
  StyleBox["Short[]", "InlineInput"],
  ". This shortening can be prevented by doing this:"
}], "Text"],

Cell[BoxData[
    \($MessagePrePrint = Identity; \)], "Input"],

Cell[TextData[{
  "This will make ",
  StyleBox["Message[]", "InlineInput"],
  " always print the full text of messages."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Recommendations", "Section"],

Cell[TextData[{
  "The interactive environment in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " supports very flexible and powerful ways to develop, test, and with \
MathCode produce executable code. However, it is a good rule to take some \
precaution of how to evaluate and redefine the declarations and functions \
that are intended for the code generation."
}], "Text"],

Cell[TextData[{
  "The normal rules of how to define and evaluate ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " packages should be used. Encapsulate the code into BeginPackage and \
EndPackage. Let all \"exported\" symbol be created outside the private \
section (marked by Begin[\"`Private`\"] and End[]), and let the function \
definitions be inside the private section. ",
  StyleBox["NOTE! When redefining a function in a package it is a good rule \
to always evaluate the complete package to prevent symbols from being created \
in the wrong context.",
    FontVariations->{"Underline"->True}],
  " To make a fresh definition of the a package symbol or function, use \
Remove to delete the created symbol and definition from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". "
}], "Text"],

Cell[TextData[{
  "If the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " notebook is used to write and test the package code, problems with \
contexts may occur. The reason for this is that the notebook parser sets the \
context for all symbols in an input cell before evaluating if the input cell \
contains a single expression. This means that if"
}], "Text"],

Cell["Begin[\"foo`\"]; fee", "Input"],

Cell["\<\
is evaluated then the context for symbol fee will not be changed. The \
solution to this is to separate all Begin, End, BeginPackage, and EndPackage \
in separate cells.\
\>", "Text"],

Cell["\<\
There is one exception from the concept of packages, for functions defined \
\"directly\" into the default context \"Global`\". In this case all symbols \
used will be put into the same context. All definitions made in the \"Global\
\.b4\" context can be compiled to the \"Global\" package by using \
CompilePackage[\"Global`\"].\
\>", "Text"],

Cell[TextData[{
  "Installing the compiled executables by using InstallCode, will store the \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " version of the functions into the container SourceDownValues. This \
container will not change if the functions are redefined in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " while the corresponding executable is installed. When using UninstallCode \
to uninstall the executable, all the functions in the package will be \
restored to the definitions they had before InstallCode was used. All changes \
in these definitions during the period when the executable was installed, are \
deleted from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". However, the internal MathCode tables are not affected, which leads to \
discrepancies between the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " definitions and definitions stored by MathCode. The following rule is \
therefore recommended:"
}], "Text"],

Cell["Do UnistallCode[] before redefining the source.", "Text",
  TextAlignment->Center,
  TextJustification->0,
  FontWeight->"Bold"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Release Information (updated for 1.1)", "Section"],

Cell[CellGroupData[{

Cell["Variable names", "Subsection"],

Cell[TextData[{
  StyleBox["dim", "InlineInput"],
  " is not an allowed variable name in MathCode, as this creates conflicts \
with internal MathCode identifiers."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Increments, Decrement, PreIncrement, PreDecrement", "Subsection"],

Cell[TextData[{
  "The occurrences of i++, ++i, i--, and --i are translated to set statements \
as i=i+1, and i=i-1. Note that this transformation is only valid when \
Increments, Decrement, PreIncrement, and PreDecrement are used as statements \
since the behavior of return values from this operations are not preserved as \
in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Strings", "Subsection"],

Cell["\<\
Only 7-bit ascii characters are supported in strings. This implies that \
international characters and other special symbols like \[Wolf] are cannot be \
converted to C++.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Blocks", "Subsection"],

Cell["\<\
The blocks Module, With, and Block can be nested and variables can be \
declared at different levels and with different scope. However, declarations \
of local variables in a nested block must be independent of prior execution \
of code in the block enclosing the block. For example\
\>", "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ y = c}, \n\t\tx\  = 3; \n\t\ Module[{y = d}, \ 
        x = y]\n]\)], "Input"],

Cell["is converted to", "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ y = c, \ y$xx\  = \ d}, \n\t\tx\  = \ 
        3; \n\t\tx\  = \ y$$xx\n\t]\)], "Input"],

Cell["This will work fine, but for the following", "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ y = c}, \n\t\tx\  = 3; \n\t
      d\  = \ x; \n\t\ Module[{y = d}, \ x = y]\n]\)], "Input"],

Cell["the conversion will fail since the resulting code is then", "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ y = c, \ y$xx\  = \ d}, \n\t\tx\  = \ 
        3; \n\t\td\  = \ x; \n\t\tx\  = \ y$$xx\n\t]\)], "Input"],

Cell["\<\
Note! The same rule is true for variable used as dimension specifiers for \
declarations of local arrays, e.g.\
\>", "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ n = c}, \n\t\tn\  = 
        3; \n\t\ Module[{Integer[n]@\ y = d}, \ x = y]\n]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Round", "Subsection"],

Cell["\<\
Converting reals to integers can be done by using Round. Round will be \
converted to the standard C function irint. Unfortunately this is not always \
the same conversion as Mathematica Round for half way numbers, where Round is \
converting to the nearest even number. How the conversion is done is \
dependent on the C-compiler used.\
\>", "Text"],

Cell["\<\
The following function can be used to test the floating point conversion.\
\>", "Text"],

Cell[BoxData[
    \(irinttest[Real\ x_]\  -> \ Integer\  := \ Round[x]; \)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ArcTan", "Subsection"],

Cell["\<\
The two input argument version of ArcTan[x_,y_] is not supported for matrix \
input arguments.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline and Range Check flags", "Subsection"],

Cell["By setting the option", "Text"],

Cell["MakeBinary[InlineFlag->True]", "Input"],

Cell["\<\
the C++ compiler will make a inline recompilation of the matrix library \
LightMat located at lib/lightmat. This recompilation is necessary to make the \
options RangeCheckFlag significant.
If\
\>", "Text"],

Cell["MakeBinary[InlineFlag->False, RangeCheckFlag->False", "Input"],

Cell["\<\
is executed the RangeCheckFlag will be obsolete since the precompiled version \
of LightMat is used in this case.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Iterators, Do, Table, Sum, Product, Array", "Subsection"],

Cell[CellGroupData[{

Cell["Zero Step Size", "Subsubsection"],

Cell["Using a zero step size in an iterator specification like", "Text"],

Cell[BoxData[
    \(Table[i, {i, start, stop, 0}]\)], "Input"],

Cell[TextData[{
  "will in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " generate an error."
}], "Text"],

Cell["\<\
For the generated code this will give an infinite loop, since this case is \
not checked for at runtime.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Table", "Subsubsection"],

Cell["\<\
The code generation for Table is only possible when the Table is placed \
directly to an assignment of a declared variable, like\
\>", "Text"],

Cell[BoxData[
    \(var\  = \ Table[i, {i, 1, 3}]\)], "Input"],

Cell[TextData[{
  "This makes it possible to translate as a loop that assigns each element of \
the variable. For the case above the corresponding ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " code is"
}], "Text"],

Cell[BoxData[{
    \(setshape[var, 3]; \), "\n", 
    \(Do[\n\t\tvar[\([\)\(i\)\(]\)]\  = \ i, \ {i, 1, 3}\n]\)}], "Input"],

Cell[TextData[{
  "The function ",
  StyleBox["setshape",
    FontFamily->"Courier"],
  " is an internal MathCode function that sets the size or dimensions of the \
data structure corresponding to ",
  StyleBox["var",
    FontFamily->"Courier"],
  " before the loop is executed. "
}], "Text"],

Cell["Remark", "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "Using iterators that is not iterated at all will in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " produce empty lists at some specific level. If the resulting table has 2 \
or more levels and one or more of its dimensions are zero, this will not be \
treated properly by ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  ". "
}], "Text"],

Cell["By externally executing the following:", "Text"],

Cell[BoxData[
    \(Table[i, {3}, {i, 1, 3, \(-1\)}]\)], "Input"],

Cell["will return", "Text"],

Cell[BoxData[
    \($Aborted\)], "Input"],

Cell[TextData[{
  "by ",
  StyleBox["MathLink.",
    FontSlant->"Italic"],
  " See section \"Zero Dimensions and ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  "\"."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["MatrixExport", "Subsection"],

Cell["Code with embedded type specifications as e.g", "Text"],

Cell["foo[Real@ x_]->Real", "Input"],

Cell[TextData[{
  "needs to load \"System/MathCodeLanguage\" to work as expected, since the \
type syntax is not a valid syntax for ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " alone."
}], "Text"],

Cell["An alternative is to use Declare as", "Text"],

Cell["Declare[foo[Real x_]->Real]", "Input"],

Cell[TextData[{
  "to provide MathCode with the necessary type information. The advantage \
with this methods is that the code will also work in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " without any preloaded packages. The Declare statement will evaluated to \
Null and ignored."
}], "Text"],

Cell["\<\
To distribute files written with MathCode embedded type syntax, please \
contact MathCore AB to download a free version of the package \
\"MathCodeLanguage`\".\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["MathLink", "Subsection"],

Cell[CellGroupData[{

Cell["Zero Dimensions and MathLink", "Subsubsection"],

Cell["\<\
When using list and tensor constructors like Table and Array it is possible \
to produce tensors with one or more zero dimensions.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(zten\  = \ Table[i + j, {i, 1, 3}, {j, 1, 3, \(-1\)}]\)], "Input"],

Cell[BoxData[
    \({{}, {}, {}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Dimensions[zten]\)], "Input"],

Cell[BoxData[
    \({3, 0}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "For the moment variables from Table and Array are declared as real or \
integer lists, matrices, or tensors where the maximum number of dimensions \
supported by MathCode is 4. Tensors with dimensions from 2 - 4 are pasted \
through ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " using the functions ",
  StyleBox["MLPutIntegerArray",
    FontFamily->"Courier"],
  " and ",
  StyleBox["MLPutRealArray",
    FontFamily->"Courier"],
  ". These function cannot handle zero dimensions which implies that if a \
zero dimension tensor is sent, the symbol ",
  StyleBox["$Aborted",
    FontFamily->"Courier"],
  " will appear as output in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ".  "
}], "Text"],

Cell[TextData[{
  "For one dimensional lists the ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " functions MLPutRealList and MLPutIntegerList are used instead which can \
handle lists of zero length. Therefore Table and Array constructors returning \
one dimensional empty lists will work correctly."
}], "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 949}},
WindowToolbars->{},
WindowSize->{944, 835},
WindowMargins->{{Automatic, 91}, {43, Automatic}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{597.563, 842.375},
"PaperOrientation"->"Portrait",
"Magnification"->1},
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Style Definitions", "Subtitle"],
  
  Cell["\<\
Modify the definitions below to change the default appearance of all cells in \
a given style.  Make modifications to any definition using commands in the \
Format menu.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    PageWidth->WindowWidth,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    ScriptMinSize->12,
    FontSize->16],
  
  Cell[StyleData[All, "Condensed"],
    PageWidth->WindowWidth,
    CellBracketOptions->{"Margins"->{1, 1},
    "Widths"->{0, 5}},
    ScriptMinSize->8,
    FontSize->11],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    ScriptMinSize->7,
    FontSize->10,
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
The options defined for the style below will be used at the Notebook level.\
\>", "Text"],
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PageHeaderLines->{True, True},
    PrintingOptions->{"FirstPageHeader"->False,
    "FacingPages"->True},
    CellFrameLabelMargins->6,
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    ShowCellBracket->False,
    CellMargins->{{0, 0}, {0, 0}},
    PageBreakBelow->False,
    LineSpacing->{1, 0},
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    FontSize->34,
    FontColor->GrayLevel[1],
    Background->RGBColor[0, 0, 1]],
  
  Cell[StyleData["Title", "Presentation"],
    CellMargins->{{0, 0}, {0, 0}},
    LineSpacing->{1, 0},
    FontSize->44],
  
  Cell[StyleData["Title", "Condensed"],
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->20],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->24,
    FontTracking->"Plain",
    Background->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    ShowCellBracket->False,
    CellMargins->{{0, 0}, {0, 0}},
    PageBreakBelow->False,
    LineSpacing->{1, 3},
    ParagraphIndent->-96,
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->18,
    FontColor->GrayLevel[1],
    Background->RGBColor[0.2, 0.700008, 0.700008]],
  
  Cell[StyleData["Subtitle", "Presentation"],
    CellMargins->{{0, 0}, {0, 0}},
    LineSpacing->{1, 6},
    ParagraphIndent->-157,
    FontSize->30],
  
  Cell[StyleData["Subtitle", "Condensed"],
    CellMargins->{{0, 0}, {0, 0}},
    ParagraphIndent->-78,
    FontSize->14],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    ParagraphIndent->-85,
    FontSize->16,
    Background->GrayLevel[0.6]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubtitle"],
    ShowCellBracket->False,
    CellMargins->{{10, 4}, {30, 10}},
    PageBreakBelow->False,
    CounterIncrements->"Subsubtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontFamily->"Helvetica",
    FontSize->14,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subsubtitle", "Presentation"],
    CellMargins->{{8, 10}, {40, 20}},
    LineSpacing->{1, 0},
    FontSize->24],
  
  Cell[StyleData["Subsubtitle", "Condensed"],
    CellMargins->{{8, 10}, {12, 8}},
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "Printout"],
    CellMargins->{{9, 10}, {50, 10}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellFrame->{{6, 0}, {0, 1}},
    CellDingbat->None,
    CellMargins->{{12, Inherited}, {4, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->6,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["Section", "Presentation"],
    CellMargins->{{10, 10}, {8, 32}},
    LineSpacing->{1, 2},
    FontSize->24,
    FontTracking->"Condensed"],
  
  Cell[StyleData["Section", "Condensed"],
    CellMargins->{{8, Inherited}, {2, 12}},
    FontSize->12],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{9, 0}, {2, 50}},
    FontSize->14,
    FontTracking->"Plain",
    FontColor->GrayLevel[0]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellMargins->{{12, Inherited}, {8, 20}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->13,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsection", "Presentation"],
    CellMargins->{{11, 10}, {8, 32}},
    LineSpacing->{1, 0},
    FontSize->22],
  
  Cell[StyleData["Subsection", "Condensed"],
    CellMargins->{{8, Inherited}, {2, 12}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{9, 0}, {4, 40}},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{25, Inherited}, {8, 12}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    CounterIncrements->"Subsubsection",
    FontFamily->"Times",
    FontSize->13,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    CellMargins->{{29, 10}, {8, 26}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Subsubsection", "Condensed"],
    CellMargins->{{22, Inherited}, {2, 12}},
    FontSize->10],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{21, 0}, {4, 20}},
    FontSize->11]
  }, Open  ]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Body Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{12, 10}, {5, 5}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 12},
    CounterIncrements->"Text",
    FontFamily->"Times"],
  
  Cell[StyleData["Text", "Presentation"],
    CellMargins->{{13, 10}, {8, 8}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12}],
  
  Cell[StyleData["Text", "Condensed"],
    CellMargins->{{8, 10}, {4, 4}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4}],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{9, 0}, {4, 4}},
    ParagraphSpacing->{0, 6}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallText"],
    CellMargins->{{12, 10}, {5, 5}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 6},
    CounterIncrements->"SmallText",
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SmallText", "Presentation"],
    CellMargins->{{13, 10}, {8, 8}},
    LineSpacing->{1, 5},
    FontSize->12],
  
  Cell[StyleData["SmallText", "Condensed"],
    CellMargins->{{8, 10}, {2, 2}},
    LineSpacing->{1, 2},
    FontSize->9],
  
  Cell[StyleData["SmallText", "Printout"],
    CellMargins->{{9, 0}, {4, 4}},
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{5, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input",
    FontWeight->"Bold",
    Background->RGBColor[1, 1, 0]],
  
  Cell[StyleData["Input", "Presentation"],
    CellMargins->{{62, Inherited}, {10, 10}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Input", "Condensed"],
    CellMargins->{{40, 10}, {4, 4}}],
  
  Cell[StyleData["Input", "Printout"],
    CellMargins->{{44, 0}, {6, 6}},
    Background->GrayLevel[0.8]]
  }, Closed]],
  
  Cell[StyleData["InlineInput"],
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    AutoItalicWords->{},
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input",
    FontWeight->"Bold"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelMargins->{{3, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Output",
    Background->RGBColor[1, 0.900008, 0.900008]],
  
  Cell[StyleData["Output", "Presentation"],
    CellMargins->{{62, Inherited}, {12, 5}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Output", "Condensed"],
    CellMargins->{{40, Inherited}, {4, 1}}],
  
  Cell[StyleData["Output", "Printout"],
    CellMargins->{{44, 0}, {6, 2}},
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    CellMargins->{{62, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontColor->RGBColor[1, 0, 0]],
  
  Cell[StyleData["Message", "Presentation"],
    CellMargins->{{74, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Message", "Condensed"],
    CellMargins->{{50, Inherited}, {Inherited, Inherited}}],
  
  Cell[StyleData["Message", "Printout"],
    CellMargins->{{54, Inherited}, {Inherited, Inherited}},
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    CellMargins->{{62, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Print",
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Presentation"],
    CellMargins->{{74, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Print", "Condensed"],
    CellMargins->{{50, Inherited}, {Inherited, Inherited}}],
  
  Cell[StyleData["Print", "Printout"],
    CellMargins->{{54, Inherited}, {Inherited, Inherited}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    CellMargins->{{62, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Graphics",
    StyleMenuListing->None],
  
  Cell[StyleData["Graphics", "Presentation"],
    CellMargins->{{74, Inherited}, {Inherited, Inherited}}],
  
  Cell[StyleData["Graphics", "Condensed"],
    CellMargins->{{52, Inherited}, {Inherited, Inherited}},
    ImageSize->{175, 175}],
  
  Cell[StyleData["Graphics", "Printout"],
    CellMargins->{{54, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->11,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["CellLabel", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["CellLabel", "Condensed"],
    FontSize->8],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontSize->8,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Unique Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Author"],
    ShowCellBracket->False,
    CellMargins->{{10, 4}, {2, 10}},
    FontSize->16,
    FontSlant->"Italic"],
  
  Cell[StyleData["Author", "Presentation"],
    CellMargins->{{12, 10}, {2, 12}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12},
    FontSize->20],
  
  Cell[StyleData["Author", "Condensed"],
    CellMargins->{{8, 10}, {1, 4}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4},
    FontSize->12],
  
  Cell[StyleData["Author", "Printout"],
    CellMargins->{{9, 0}, {4, 12}},
    ParagraphSpacing->{0, 6},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Copyright"],
    ShowCellBracket->False,
    CellMargins->{{10, 10}, {40, 2}},
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["Copyright", "Presentation"],
    CellMargins->{{12, 10}, {50, 2}},
    LineSpacing->{1, 5},
    FontSize->12],
  
  Cell[StyleData["Copyright", "Condensed"],
    CellMargins->{{8, 10}, {12, 1}},
    LineSpacing->{1, 2},
    FontSize->9],
  
  Cell[StyleData["Copyright", "Printout"],
    CellMargins->{{9, 0}, {72, 4}},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Example"],
    CellMargins->{{12, 10}, {5, 12}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 12},
    CounterIncrements->"Example",
    FontFamily->"Times",
    FontWeight->"Bold"],
  
  Cell[StyleData["Example", "Presentation"],
    CellMargins->{{18, 10}, {8, 20}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12}],
  
  Cell[StyleData["Example", "Condensed"],
    CellMargins->{{8, 10}, {4, 8}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4}],
  
  Cell[StyleData["Example", "Printout"],
    CellMargins->{{9, 0}, {4, 10}},
    ParagraphSpacing->{0, 6}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Definition"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    ShowStringCharacters->True,
    CounterIncrements->"Definition",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.2, 0.700008, 0.700008]],
  
  Cell[StyleData["Definition", "Presentation"],
    CellMargins->{{62, Inherited}, {5, 12}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Definition", "Condensed"],
    CellMargins->{{40, 10}, {1, 4}}],
  
  Cell[StyleData["Definition", "Printout"],
    CellMargins->{{44, 0}, {2, 6}},
    Background->GrayLevel[0.6]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Theorem"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    ShowStringCharacters->True,
    CounterIncrements->"Theorem",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["Theorem", "Presentation"],
    CellMargins->{{62, Inherited}, {5, 12}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Theorem", "Condensed"],
    CellMargins->{{40, 10}, {1, 4}}],
  
  Cell[StyleData["Theorem", "Printout"],
    CellMargins->{{44, 0}, {2, 6}},
    Background->GrayLevel[0.4]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExerciseMain"],
    CellFrame->{{6, 0}, {0, 1}},
    CellMargins->{{12, Inherited}, {4, 20}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.571389, 0.19675, 0.570504],
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["ExerciseMain", "Presentation"],
    CellMargins->{{18, 10}, {8, 32}},
    LineSpacing->{1, 2},
    FontSize->24,
    FontTracking->"Condensed"],
  
  Cell[StyleData["ExerciseMain", "Condensed"],
    CellMargins->{{8, Inherited}, {2, 12}},
    FontSize->12],
  
  Cell[StyleData["ExerciseMain", "Printout"],
    CellMargins->{{9, 0}, {2, 50}},
    CellFrameColor->GrayLevel[0.500008],
    FontSize->14,
    FontTracking->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Exercise"],
    CellDingbat->"\[FilledDownTriangle]",
    CellMargins->{{23, Inherited}, {4, 18}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    CounterIncrements->"Subsubsection",
    FontFamily->"Times",
    FontSize->13,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["Exercise", "Presentation"],
    CellMargins->{{33, 10}, {8, 26}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Exercise", "Condensed"],
    CellMargins->{{17, Inherited}, {2, 12}},
    FontSize->10],
  
  Cell[StyleData["Exercise", "Printout"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellDingbat->None,
    CellMargins->{{9, 0}, {6, 20}},
    FontSize->11,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExerciseText"],
    CellMargins->{{62, 10}, {5, 5}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 8},
    CounterIncrements->"ExcersiceText",
    FontFamily->"Times"],
  
  Cell[StyleData["ExerciseText", "Presentation"],
    CellMargins->{{74, 10}, {8, 8}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12}],
  
  Cell[StyleData["ExerciseText", "Condensed"],
    CellMargins->{{52, 10}, {2, 2}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4}],
  
  Cell[StyleData["ExerciseText", "Printout"],
    CellMargins->{{54, 0}, {4, 4}},
    ParagraphSpacing->{0, 6}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Itemize"],
    CellDingbat->"\[FilledSmallCircle]",
    CellMargins->{{65, Inherited}, {8, 8}},
    FontFamily->"Times",
    FontSize->13,
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontVariations->{"Underline"->False,
    "Outline"->False,
    "Shadow"->False}],
  
  Cell[StyleData["Itemize", "Presentation"],
    CellMargins->{{Inherited, 10}, {8, 12}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Itemize", "Condensed"],
    CellMargins->{{Inherited, Inherited}, {2, 12}},
    FontSize->10],
  
  Cell[StyleData["Itemize", "Printout"],
    CellMargins->{{Inherited, 0}, {4, 20}},
    FontSize->11]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayCode"],
    CellFrame->2,
    CellMargins->{{52, 10}, {8, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->True,
    CellLabelMargins->{{5, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    FontWeight->"Bold",
    Background->RGBColor[1, 1, 0]],
  
  Cell[StyleData["DisplayCode", "Presentation"],
    CellMargins->{{62, Inherited}, {10, 10}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["DisplayCode", "Condensed"],
    CellMargins->{{40, 10}, {4, 4}}],
  
  Cell[StyleData["DisplayCode", "Printout"],
    CellMargins->{{44, 0}, {6, 6}},
    Background->GrayLevel[0.8]]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{62, 10}, {2, 10}},
    CellHorizontalScrolling->True,
    ScriptLevel->0,
    SingleLetterItalics->True,
    UnderoverscriptBoxOptions->{LimitsPositioning->True}],
  
  Cell[StyleData["DisplayFormula", "Presentation"],
    CellMargins->{{74, 10}, {2, 10}},
    FontSize->18],
  
  Cell[StyleData["DisplayFormula", "Condensed"],
    CellMargins->{{52, 10}, {2, 10}},
    FontSize->10],
  
  Cell[StyleData["DisplayFormula", "Printout"],
    CellMargins->{{54, 10}, {2, 10}},
    FontSize->10]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ChemicalFormula"],
    CellMargins->{{62, 10}, {2, 10}},
    AutoSpacing->False,
    ScriptLevel->1,
    ScriptBaselineShifts->{0.6, Automatic},
    SingleLetterItalics->False,
    ZeroWidthTimes->True],
  
  Cell[StyleData["ChemicalFormula", "Presentation"],
    CellMargins->{{74, 10}, {2, 10}},
    FontSize->10],
  
  Cell[StyleData["ChemicalFormula", "Condensed"],
    CellMargins->{{52, 10}, {2, 10}},
    FontSize->10],
  
  Cell[StyleData["ChemicalFormula", "Printout"],
    CellMargins->{{54, 10}, {2, 10}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellMargins->{{12, 10}, {Inherited, 6}},
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Presentation"],
    CellMargins->{{13, 30}, {Inherited, 4}},
    FontSize->9.5],
  
  Cell[StyleData["Program", "Condensed"],
    CellMargins->{{8, 10}, {Inherited, 4}},
    FontSize->9.5],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{9, 0}, {Inherited, 4}},
    FontSize->9.5]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Automatic Numbering", "Section"],
  
  Cell["\<\
The following styles are useful for numbered equations, figures, etc.  They \
automatically give the cell a FrameLabel containing a reference to a \
particular counter, and also increment that counter.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedEquation"],
    CellMargins->{{62, 10}, {Inherited, Inherited}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "NumberedEquation"], ")"}]]}, {None, None}},
    DefaultFormatType->DefaultInputFormatType,
    CounterIncrements->"NumberedEquation",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedEquation", "Presentation"],
    CellMargins->{{74, 10}, {Inherited, Inherited}}],
  
  Cell[StyleData["NumberedEquation", "Condensed"],
    CellMargins->{{52, 10}, {Inherited, Inherited}}],
  
  Cell[StyleData["NumberedEquation", "Printout"],
    CellMargins->{{54, 0}, {Inherited, Inherited}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedFigure"],
    CellMargins->{{62, 145}, {Inherited, Inherited}},
    CellFrameLabels->{{None, None}, {Cell[ 
            TextData[ {"Figure ", 
              CounterBox[ "NumberedFigure"]}]], None}},
    CounterIncrements->"NumberedFigure",
    ImageMargins->{{43, Inherited}, {Inherited, 0}},
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedFigure", "Presentation"]],
  
  Cell[StyleData["NumberedFigure", "Condensed"]],
  
  Cell[StyleData["NumberedFigure", "Printout"]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedTable"],
    CellMargins->{{62, 145}, {Inherited, Inherited}},
    CellFrameLabels->{{None, None}, {Cell[ 
            TextData[ {"Table ", 
              CounterBox[ "NumberedTable"]}]], None}},
    TextAlignment->Center,
    CounterIncrements->"NumberedTable",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedTable", "Presentation"]],
  
  Cell[StyleData["NumberedTable", "Condensed"]],
  
  Cell[StyleData["NumberedTable", "Printout"]]
  }, Open  ]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headers and Footers", "Section"],
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontSlant->"Italic"],
  
  Cell[StyleData["Footer"],
    CellMargins->{{0, 0}, {0, 4}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->6],
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Bold"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlink Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext ButtonBoxes.  The \
\"Hyperlink\" style is for links within the same Notebook, or between \
Notebooks.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions -> {Appearance -> {Automatic, None}},
    FontColor->RGBColor[0, 0, 1],
    Background->None,
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Presentation"]],
  
  Cell[StyleData["Hyperlink", "Condensed"]],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Open  ]],
  
  Cell["\<\
The following styles are for linking automatically to the on-line help \
system.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions -> {Appearance -> {Automatic, None}},
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True}],
  
  Cell[StyleData["MainBookLink", "Presentation"]],
  
  Cell[StyleData["MainBookLink", "Condensed"]],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions -> {Appearance -> {Automatic, None}},
    FontFamily->"Courier",
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True}],
  
  Cell[StyleData["AddOnsLink", "Presentation"]],
  
  Cell[StyleData["AddOnsLink", "Condensed"]],
  
  Cell[StyleData["AddOnLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions -> {Appearance -> {Automatic, None}},
    FontFamily->"Courier",
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuideLink", #]}]&),
    Active->True}],
  
  Cell[StyleData["RefGuideLink", "Presentation"]],
  
  Cell[StyleData["RefGuideLink", "Condensed"]],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions -> {Appearance -> {Automatic, None}},
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True}],
  
  Cell[StyleData["GettingStartedLink", "Presentation"]],
  
  Cell[StyleData["GettingStartedLink", "Condensed"]],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions -> {Appearance -> {Automatic, None}},
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True}],
  
  Cell[StyleData["OtherInformationLink", "Presentation"]],
  
  Cell[StyleData["OtherInformationLink", "Condensed"]],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 44, 0, 55, "Title"],
Cell[1801, 53, 102, 1, 41, "Subtitle"],
Cell[1906, 56, 110, 1, 58, "Subsubtitle"],

Cell[CellGroupData[{
Cell[2041, 61, 46, 0, 56, "Section"],
Cell[2090, 63, 1115, 27, 141, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3242, 95, 125, 1, 56, "Section"],
Cell[3370, 98, 942, 19, 91, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4349, 122, 125, 1, 56, "Section"],
Cell[4477, 125, 2192, 42, 587, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6706, 172, 41, 0, 56, "Section"],
Cell[6750, 174, 605, 13, 153, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7392, 192, 41, 0, 56, "Section"],
Cell[7436, 194, 198, 8, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7671, 207, 41, 0, 56, "Section"],
Cell[7715, 209, 176, 2, 91, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7928, 216, 54, 0, 56, "Section"],
Cell[7985, 218, 1216, 28, 370, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9238, 251, 51, 0, 56, "Section"],
Cell[9292, 253, 575, 11, 184, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9904, 269, 41, 0, 70, "Section"],
Cell[9948, 271, 734, 13, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10719, 289, 39, 0, 70, "Section"],
Cell[10761, 291, 926, 17, 70, "Text"],

Cell[CellGroupData[{
Cell[11712, 312, 73, 0, 70, "Subsection"],
Cell[11788, 314, 268, 6, 70, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12105, 326, 58, 0, 70, "Section"],
Cell[12166, 328, 207, 6, 70, "Text"],

Cell[CellGroupData[{
Cell[12398, 338, 121, 3, 70, "Subsection"],
Cell[12522, 343, 1574, 39, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14133, 387, 60, 3, 70, "Subsection"],
Cell[14196, 392, 383, 8, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14616, 405, 49, 0, 70, "Subsection"],
Cell[14668, 407, 215, 4, 70, "Itemize"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14920, 416, 39, 3, 70, "Subsection"],
Cell[14962, 421, 79, 0, 70, "Itemize"],
Cell[15044, 423, 35, 0, 70, "Itemize"],
Cell[15082, 425, 96, 2, 70, "Itemize"],
Cell[15181, 429, 49, 0, 70, "Itemize"],
Cell[15233, 431, 75, 0, 70, "Itemize"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15345, 436, 48, 0, 70, "Subsection"],
Cell[15396, 438, 260, 7, 70, "Text"],
Cell[15659, 447, 62, 1, 70, "Input"],
Cell[15724, 450, 133, 4, 70, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[15906, 460, 29, 0, 70, "Section"],
Cell[15938, 462, 373, 8, 70, "Text"],

Cell[CellGroupData[{
Cell[16336, 474, 54, 0, 70, "Subsection"],
Cell[16393, 476, 394, 9, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16824, 490, 43, 0, 70, "Subsection"],
Cell[16870, 492, 407, 12, 70, "Text"],
Cell[17280, 506, 254, 5, 70, "Text"],
Cell[17537, 513, 304, 7, 70, "Text"],
Cell[17844, 522, 78, 1, 70, "Input"],
Cell[17925, 525, 196, 4, 70, "Text"],
Cell[18124, 531, 75, 1, 70, "Input"],
Cell[18202, 534, 269, 9, 70, "Text"],
Cell[18474, 545, 262, 6, 70, "Text"],
Cell[18739, 553, 94, 2, 70, "Input",
  Evaluatable->False],
Cell[18836, 557, 277, 5, 70, "Text"],
Cell[19116, 564, 68, 1, 70, "Input"],
Cell[19187, 567, 353, 9, 70, "Text"],
Cell[19543, 578, 91, 1, 70, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19671, 584, 61, 0, 70, "Subsection"],
Cell[19735, 586, 3287, 93, 70, "Text"],
Cell[23025, 681, 247, 4, 70, "Itemize"],
Cell[23275, 687, 226, 6, 70, "Itemize"],
Cell[23504, 695, 264, 6, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[23805, 706, 48, 0, 70, "Subsection"],
Cell[23856, 708, 1034, 23, 70, "Text"],
Cell[24893, 733, 215, 4, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[25145, 742, 30, 0, 70, "Subsection"],
Cell[25178, 744, 215, 5, 70, "Text"],
Cell[25396, 751, 303, 6, 70, "Text"],
Cell[25702, 759, 205, 6, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[25944, 770, 35, 0, 70, "Subsection"],
Cell[25982, 772, 434, 8, 70, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[26465, 786, 30, 0, 70, "Section"],
Cell[26498, 788, 271, 6, 70, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[26806, 799, 30, 0, 70, "Section"],
Cell[26839, 801, 204, 4, 70, "Text"],
Cell[27046, 807, 75, 0, 70, "Text"],
Cell[27124, 809, 140, 4, 70, "Itemize"],
Cell[27267, 815, 118, 3, 70, "Itemize"],
Cell[27388, 820, 145, 4, 70, "Itemize"],
Cell[27536, 826, 139, 4, 70, "Itemize"]
}, Closed]],

Cell[CellGroupData[{
Cell[27712, 835, 26, 0, 70, "Section"],

Cell[CellGroupData[{
Cell[27763, 839, 44, 0, 70, "Subsection"],
Cell[27810, 841, 152, 3, 70, "Text"],

Cell[CellGroupData[{
Cell[27987, 848, 35, 0, 70, "Subsubsection"],
Cell[28025, 850, 271, 5, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28333, 860, 38, 0, 70, "Subsubsection"],
Cell[28374, 862, 233, 4, 70, "Text"],
Cell[28610, 868, 416, 10, 70, "Text"],
Cell[29029, 880, 103, 2, 70, "Input"],
Cell[29135, 884, 73, 0, 70, "Text"],
Cell[29211, 886, 124, 3, 70, "Text"],
Cell[29338, 891, 118, 5, 70, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[29505, 902, 43, 0, 70, "Subsection"],
Cell[29551, 904, 289, 8, 70, "Text"],
Cell[29843, 914, 182, 3, 70, "Message"],
Cell[30028, 919, 235, 6, 70, "Text"],
Cell[30266, 927, 104, 2, 70, "Input"],
Cell[30373, 931, 262, 6, 70, "Text"],
Cell[30638, 939, 147, 2, 70, "Input"],
Cell[30788, 943, 156, 3, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30981, 951, 48, 0, 70, "Subsection"],
Cell[31032, 953, 260, 7, 70, "Text"],
Cell[31295, 962, 62, 1, 70, "Input"],
Cell[31360, 965, 133, 4, 70, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[31542, 975, 34, 0, 70, "Section"],
Cell[31579, 977, 386, 8, 70, "Text"],
Cell[31968, 987, 816, 17, 70, "Text"],
Cell[32787, 1006, 373, 8, 70, "Text"],
Cell[33163, 1016, 37, 0, 70, "Input"],
Cell[33203, 1018, 193, 4, 70, "Text"],
Cell[33399, 1024, 353, 6, 70, "Text"],
Cell[33755, 1032, 987, 22, 70, "Text"],
Cell[34745, 1056, 134, 3, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[34916, 1064, 56, 0, 70, "Section"],

Cell[CellGroupData[{
Cell[34997, 1068, 36, 0, 70, "Subsection"],
Cell[35036, 1070, 175, 4, 70, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[35248, 1079, 71, 0, 70, "Subsection"],
Cell[35322, 1081, 402, 9, 70, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[35761, 1095, 29, 0, 70, "Subsection"],
Cell[35793, 1097, 195, 4, 70, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[36025, 1106, 28, 0, 70, "Subsection"],
Cell[36056, 1108, 306, 5, 70, "Text"],
Cell[36365, 1115, 119, 2, 70, "Input"],
Cell[36487, 1119, 31, 0, 70, "Text"],
Cell[36521, 1121, 128, 2, 70, "Input"],
Cell[36652, 1125, 58, 0, 70, "Text"],
Cell[36713, 1127, 132, 2, 70, "Input"],
Cell[36848, 1131, 73, 0, 70, "Text"],
Cell[36924, 1133, 145, 2, 70, "Input"],
Cell[37072, 1137, 134, 3, 70, "Text"],
Cell[37209, 1142, 132, 2, 70, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37378, 1149, 27, 0, 70, "Subsection"],
Cell[37408, 1151, 360, 6, 70, "Text"],
Cell[37771, 1159, 97, 2, 70, "Text"],
Cell[37871, 1163, 85, 1, 70, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37993, 1169, 28, 0, 70, "Subsection"],
Cell[38024, 1171, 118, 3, 70, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[38179, 1179, 50, 0, 70, "Subsection"],
Cell[38232, 1181, 37, 0, 70, "Text"],
Cell[38272, 1183, 45, 0, 70, "Input"],
Cell[38320, 1185, 216, 5, 70, "Text"],
Cell[38539, 1192, 68, 0, 70, "Input"],
Cell[38610, 1194, 137, 3, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38784, 1202, 63, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[38872, 1206, 39, 0, 70, "Subsubsection"],
Cell[38914, 1208, 72, 0, 70, "Text"],
Cell[38989, 1210, 62, 1, 70, "Input"],
Cell[39054, 1213, 117, 5, 70, "Text"],
Cell[39174, 1220, 128, 3, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39339, 1228, 30, 0, 70, "Subsubsection"],
Cell[39372, 1230, 152, 3, 70, "Text"],
Cell[39527, 1235, 62, 1, 70, "Input"],
Cell[39592, 1238, 226, 6, 70, "Text"],
Cell[39821, 1246, 123, 2, 70, "Input"],
Cell[39947, 1250, 292, 9, 70, "Text"],
Cell[40242, 1261, 44, 1, 70, "Text"],
Cell[40289, 1264, 373, 10, 70, "Text"],
Cell[40665, 1276, 54, 0, 70, "Text"],
Cell[40722, 1278, 65, 1, 70, "Input"],
Cell[40790, 1281, 27, 0, 70, "Text"],
Cell[40820, 1283, 41, 1, 70, "Input"],
Cell[40864, 1286, 184, 8, 70, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[41097, 1300, 34, 0, 70, "Subsection"],
Cell[41134, 1302, 61, 0, 70, "Text"],
Cell[41198, 1304, 36, 0, 70, "Input"],
Cell[41237, 1306, 210, 6, 70, "Text"],
Cell[41450, 1314, 51, 0, 70, "Text"],
Cell[41504, 1316, 44, 0, 70, "Input"],
Cell[41551, 1318, 308, 7, 70, "Text"],
Cell[41862, 1327, 183, 4, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[42082, 1336, 30, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[42137, 1340, 53, 0, 70, "Subsubsection"],
Cell[42193, 1342, 154, 3, 70, "Text"],

Cell[CellGroupData[{
Cell[42372, 1349, 86, 1, 70, "Input"],
Cell[42461, 1352, 46, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[42544, 1358, 49, 1, 70, "Input"],
Cell[42596, 1361, 40, 1, 70, "Output"]
}, Open  ]],
Cell[42651, 1365, 734, 21, 70, "Text"],
Cell[43388, 1388, 320, 7, 70, "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

